#ifndef ARBGIOINT_HPP
#define ARBGIOINT_HPP

#include "ArbreGen.hpp"

// Lectura d'un arbre general d'enters, acci.  Els elements
// s'introdueixen en preordre: primer l'arrel, deprs el nombre de
// fills n i desprs els n fills. Els arbres buits es representen amb
// la marca. 

/* Exemple: l'arbre 

     1
   / | \
  2  -  3


   es llegeix 1 3 2 0 0 3 0  

  on el segon fill es buit
*/

void llegir_arbreGen_int(ArbreGen<int>& a, int marca){
/* Pre: a es buit; el canal estandar d'entrada cont el recorregut en preordre
   d'un arbre general A d'enters marcat amb "marca" */  
/* Post: a = A */
  int x;
  cin >> x;
  //cout << x << " ";
  if (x!= marca) {
    int m;
    cin >> m;
    //cout << "*" << m << " ";
    vector<ArbreGen<int> > v(m);
    for (int i=0; i<m; ++i)
      llegir_arbreGen_int(v[i], marca);
    a.plantar(x,v);
  }
}

// Escriptura d'un arbre general d'enteros, acci.  Els elements 
// s'escriuen tamb en preordre

/* Exemple: l'arbre 

     1
   / | \
  2  4  3

   s'escriu 1 2 4 3 */

void escriure_arbreGen_int(ArbreGen<int> &a) {
/* Pre: cert */ 
/* Post: El canal estandar de sortida cont el recorregut en preordre d'a */ 
  if (not a.es_buit()) {
    int x = a.arrel();
    int m= a.nombre_fills();
    vector<ArbreGen<int> > va;
    a.fills(va);
    cout << x << " ";
    for (int i=0; i<m; ++i)
      escriure_arbreGen_int(va[i]); 
    a.plantar(x,va);    
  }
}

#endif
