#include "utils.PRO2"
#include "Arbre.hpp"
#include "ArbIOint.hpp"

int altura(Arbre<int>& a)
/* Pre: a=A */
{
  if (a.es_buit()) return 0;
  else{
        Arbre<int> a1;
        Arbre<int> a2;
        a.fills(a1,a2);
        int y=altura(a1);
        int z=altura(a2);
	return max(y,z)+1;
  }
}
/* Post: El resultat és la longitud del camí més llarg de l'arrel a una fulla 
   de l'arbre A; a és buit */





int mida(Arbre<int>& a)
/* Pre: a=A */
{
 if (a.es_buit()) return 0;
  else{
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    int y=mida(a1);
    int z=mida(a2);   
    return y+z+1;
  }
}
/* Post: El resultat és el nombre de nodes de l'arbre A */



bool cerca(Arbre<int>& a, int x)
/* Pre: a=A */
{
  bool b;
  if (a.es_buit()) return false;
  else if (a.arrel()==x) return true;
  else{
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    b=cerca(a1,x);
    if (not b) return cerca(a2,x);
    else return true;
  }
}
/* Post: El resultat indica si x és a l'arbre A o no */


void suma(Arbre<int> &a, int k)
/* Pre: a=A */
{
  if (not a.es_buit()){
    int n=a.arrel()+k;
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);         
    suma(a1,k);
    suma(a2,k);
    a.plantar(n,a1,a2);
  }
}
/* Post: El valor de cada node d'a és la suma del valor del node corresponent 
   d'A i el valor k */


Arbre<int> sumaf(Arbre<int> &a, int k)
/* Pre: a=A */
{
  Arbre<int> b;
  if (not a.es_buit()){
    int n=a.arrel()+k;
    Arbre<int> a1;
    Arbre<int> a2;
    a.fills(a1,a2);
    Arbre<int> b1=sumaf(a1,k);
    Arbre<int> b2=sumaf(a2,k);
    b.plantar(n,b1,b2);
  }
  return b;
}
/* Post: El valor de cada node del resultat és la suma del valor del node 
   corresponent d'A i el valor k */

//Aqueta solució fa moltes còpies.


/* Pre: a=A , b = B */
bool iguals(Arbre<int> &a, Arbre<int> &b){
  if (a.es_buit() and b.es_buit()) return true;
  if (a.es_buit() or b.es_buit()) return false;
  else {
    if (a.arrel() != b.arrel()) return false;
    else{
      Arbre<int> a1;
      Arbre<int> a2;
      a.fills(a1,a2);
      Arbre<int> b1;
      Arbre<int> b2;
      b.fills(b1,b2); 
      if (not iguals(a1,b1)) return false;
      else return iguals(a2,b2);
    }
  }
}
// Post: retorna si A i B són iguals o no



int main(){

  Arbre<int> a;
  llegir_arbre_int(a,0);
  int n;
  Arbre<int> b;
  b=a;
  escriure_arbre_int(b);
  cout << endl;
  b=a;
  cout << "Altura: " << altura(b) << endl;
  b=a;
  cout << "Mida: " << mida(b) << endl;
  b=a;
  cout << "Número a cercar: "; 
  cin >> n;
  if (cerca(b,n)) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
  b=a;
  cout << "Número a afegir: "; 
  cin >> n;
  suma(b,n);
  escriure_arbre_int(b);
  cout << endl;
  b=a;
  cout << "Número a afegir: "; 
  cin >> n;
  Arbre<int> c = sumaf(b,n);
  escriure_arbre_int(c);
  cout << endl;
}



